#
# To build against different kernel use: --define "kernel_version VERSION-RELEASE"
#

# Q: should we try to build "timesource" driver?
# A: not yet - it cannot be build in a kernel-independent way
%define with_timesource 0

Name: mshvic
Version: 2.1.2
Release: 11%{?dist}
License: BSD/GPLv2
Group: System/Kernel
Summary: Linux Integration Services for Hyper-V (TM)
Packager: Linux.Support@cern.ch
Vendor: CERN, http://cern.ch/linux
Source0: LinuxIC-BSD-GPL.tar.bz2
Source1: %{name}-depmod.conf
#Source2: %{name}-mkinitrd.conf
Source3: %{name}-depmod-timesource.conf
#Source4: %{name}-mkinitrd-timesource.conf
Source5: %{name}-trigger.pl
BuildRoot: %{_tmppath}/%{name}-%{version}-build
Provides: %{name}-kmod-common = %{?epoch:%{epoch}:}%{version}

Source1111: slc-kmodtool-mshvic
BuildRequires: %kernel_module_package_buildreqs
%if %{with_timesource}
BuildRequires: adjtimex
%endif

%define upvar default
%ifarch i686
%define paevar PAE
%endif
#%ifarch i686 ia64 x86_64
#%define xenvar xen
#%endif

%kernel_module_package -s %{SOURCE1111} %{?upvar} %{?paevar}

%description
Linux Integration Services for Hyper-V (TM) in
Windows Server 2008, Windows Server 2008 R2, Microsoft
Hyper-V Server 2008 and Microsoft Hyper-V Server 2008 R2.

Contains drivers for the following:
VMBus
Microsoft synthetic SCSI controller
Microsoft synthetic network adapter

Copyright (c) 2010, Microsoft Corporation.

Version : 2.1.2
Date    : March 31, 2010

%prep
%setup -c -n %{name}-%{version}/
set -- *
mkdir source
ls -l
mv "$@" source/
mkdir obj

%build
for flavor in %{flavors_to_build} ; do
   rm -rf obj/$flavor
   cp -r source obj/$flavor
   make -C %{kernel_source $flavor} M=`pwd`/obj/$flavor/LinuxIC-BSD-GPL/src/
%if %{with_timesource}
   make -C %{kernel_source $flavor} M=`pwd`/obj/$flavor/LinuxIC-BSD-GPL/src/ obj-m=hv_timesource.o
%endif
done

%install
for flavor in %flavors_to_build ; do 
   kmodloc="$RPM_BUILD_ROOT/lib/modules/%{kernel_version}"
   if [ "$flavor" != "default" ]; then
    kmodloc="$kmodloc$flavor"
   fi
   kmodloc="$kmodloc/extra"
   install -d -m0755 $kmodloc/
   install -m0755 obj/$flavor/LinuxIC-BSD-GPL/src/vmbus.ko $kmodloc/
   install -m0755 obj/$flavor/LinuxIC-BSD-GPL/src/blkvsc.ko $kmodloc/
   install -m0755 obj/$flavor/LinuxIC-BSD-GPL/src/storvsc.ko $kmodloc/
   install -m0755 obj/$flavor/LinuxIC-BSD-GPL/src/netvsc.ko $kmodloc/
%if %{with_timesource}
   install -m0755 obj/$flavor/LinuxIC-BSD-GPL/src/hv_timesource.ko $kmodloc/
%endif
done
install -d -m0755 $RPM_BUILD_ROOT/%{_sysconfdir}/vmbus
install -m0755 source/LinuxIC-BSD-GPL/scripts/vmbus.uevent $RPM_BUILD_ROOT/%{_sysconfdir}/vmbus/
install -m0755 source/LinuxIC-BSD-GPL/scripts/netvsc.uevent $RPM_BUILD_ROOT/%{_sysconfdir}/vmbus/
install -d -m0755 $RPM_BUILD_ROOT/%{_sysconfdir}/udev/rules.d
install -m0644 source/LinuxIC-BSD-GPL/scripts/20-vmbus.rules $RPM_BUILD_ROOT/%{_sysconfdir}/udev/rules.d/
#new line for Jan
echo "" >> $RPM_BUILD_ROOT/%{_sysconfdir}/udev/rules.d/20-vmbus.rules
install -m0644 source/LinuxIC-BSD-GPL/scripts/20-netvsc.rules $RPM_BUILD_ROOT/%{_sysconfdir}/udev/rules.d/
#install -d -m0755 $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/network-scripts
#install -m0644 source/LinuxIC-BSD-GPL/scripts/ifcfg-seth $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/network-scripts/ifcfg-seth0
#install -m0644 source/LinuxIC-BSD-GPL/scripts/ifcfg-seth $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/network-scripts/ifcfg-seth1
##missing ONBOOT for Jan
#echo "ONBOOT=no" >> $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/network-scripts/ifcfg-seth0
#echo "ONBOOT=no" >> $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/network-scripts/ifcfg-seth1
#echo "NM_CONTROLLED=no" >> $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/network-scripts/ifcfg-seth0
#echo "NM_CONTROLLED=no" >> $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/network-scripts/ifcfg-seth1
install -d -m0755 $RPM_BUILD_ROOT/%{_sysconfdir}/init.d/
install -m0755 source/LinuxIC-BSD-GPL/scripts/vmbus $RPM_BUILD_ROOT/%{_sysconfdir}/init.d/
install -d -m0755 $RPM_BUILD_ROOT/%{_sysconfdir}/depmod.d/
#install -d -m0755 $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/mkinitrd/
%if ! %{with_timesource}
install -m0644 %{SOURCE1} $RPM_BUILD_ROOT/%{_sysconfdir}/depmod.d/%{name}.conf
#install -m0755 %{SOURCE2} $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/mkinitrd/%{name}
%else
install -m0644 %{SOURCE3} $RPM_BUILD_ROOT/%{_sysconfdir}/depmod.d/%{name}.conf
#install -m0755 %{SOURCE4} $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/mkinitrd/%{name}
%endif
install -d -m0755 $RPM_BUILD_ROOT/var/run/%{name}/
install -d -m0755 $RPM_BUILD_ROOT/usr/sbin
install -m0755 %{SOURCE5} $RPM_BUILD_ROOT/usr/sbin/

%clean
rm -rf %{buildroot}

%post
#echo %post - \$1 = $1
echo "Enable MSHVIC services"
/sbin/chkconfig --add vmbus || :
/sbin/chkconfig --levels 345 vmbus on ||:
/sbin/udevcontrol reload_rules ||:

%preun
#echo %preun - \$1 = $1
#[ $1 = 0 ] && echo "Removing MSHVIC modules in initrd(s) and removing parameters to grub configuration"
[ $1 = 0 ] && /usr/sbin/mshvic-trigger.pl uninstall ||:

%postun
#echo %postun - \$1 = $1
/sbin/udevcontrol reload_rules ||:

%files
%defattr(-,root,root,-)
%config %{_sysconfdir}/depmod.d/%{name}.conf
%{_sysconfdir}/init.d/vmbus
#%config %{_sysconfdir}/sysconfig/mkinitrd/%{name}
%config %{_sysconfdir}/vmbus/vmbus.uevent
%config %{_sysconfdir}/vmbus/netvsc.uevent
%config %{_sysconfdir}/udev/rules.d/20-vmbus.rules
%config %{_sysconfdir}/udev/rules.d/20-netvsc.rules
#%config %{_sysconfdir}/sysconfig/network-scripts/ifcfg-seth0
#%config %{_sysconfdir}/sysconfig/network-scripts/ifcfg-seth1
/usr/sbin/mshvic-trigger.pl
%dir /var/run/mshvic

%doc source/LinuxIC-BSD-GPL/LICENSE-GPL source/LinuxIC-BSD-GPL/LICENSE-DUAL-BSD-GPL source/LinuxIC-BSD-GPL/README source/LinuxIC-BSD-GPL/docs/LinuxIC_UserGuide.pdf

%changelog
* Tue Aug 24 2010 Jan van Eldik <Jan.van.Eldik@cern.ch> 2.1.2-11
- upgrade to officially released Integration Components:
   http://www.microsoft.com/downloads/details.aspx?displaylang=en&FamilyID=eee39325-898b-4522-9b4c-f4b5b9b64551
- improvements in mshvic-trigger script:
  - don't run mshvic-trigger script in %post install
  - drop /etc/sysconfig/network-scripts/ifcfg-seth{0,1} from the packaging
  - many cleanups

* Thu Jun 17 2010 Jan van Eldik <Jan.van.Eldik@cern.ch> 2.1.2-RC.10
- drop building for kernel-xen, many small fixes

* Fri Jun 04 2010 Jaroslaw Polok <jaroslaw.polok@cern.ch>
- added better config script, added trigger by rpm.

* Mon May 17 2010 Jaroslaw Polok <jaroslaw.polok@cern.ch>
- updated to 2.1.2 rc1

* Fri Apr 30 2010 Jaroslaw Polok <jaroslaw.polok@cern.ch> 
- initial version
- packaging changed to DUP: http://driverupdateprogram.com/
